// *************************************************************************
//    CoralBreak.h
// *************************************************************************

#ifndef _CoralBreak_H_
#define _CoralBreak_H_

#include "BitVector.h"

// *************************************************************************

#define    NUM_RULES    50

class Cor_break_info {
  public:
    char module_name[80];
    int all;                        // flag to break all
    int module_flag;                // flag to break on module
    Cor_BitVector *scc_flags;       // bitvector used to control scc break
                                    // bitvector used to control rule break
    Cor_BitVector *rule_flags[NUM_RULES];

    Cor_break_info() {
        module_name[0] = '\0';
        all = 0;
        module_flag = 0;
        scc_flags = NULL;
        for (int j=0; j < NUM_RULES; j++)
            rule_flags[j] = NULL;
    }

   ~Cor_break_info() {
        delete scc_flags;
        for (int j=0; j < NUM_RULES; j++)
            delete rule_flags[j];
    }
};

// *************************************************************************
#undef    NUM_RULES

extern int Cor_opt;           // flag turned on if coral break is set

extern char *Cor_Scc_String;
extern char *Cor_Iteration_String;
extern char *Cor_Rule_String;

extern char *Cor_dump_str;
extern char *Cor_my_str;

extern Cor_break_info *Cor_brk_Info;

// *************************************************************************

void coral_break(char *s, int id);

// *************************************************************************

#endif _BreakInfo_H_
