// *************************************************************************
//    Globals.h
// *************************************************************************

#ifndef _Globals_H_
#define _Globals_H_

#include "ExecutionEnv.h"
#include "ParserStruct.h"
#include "ParserEnv.h"
#include "TableStack.h"
#include "CoralConfig.h"
#include "ParseStack.h"
#include "Trail.h"
#include "ConnectArray.h"

// *************************************************************************
// See Globals.C for explanations of these things.
// *************************************************************************

extern Cor_Trail        *Cor_CurTrail;

extern Cor_ExecutionEnv *Cor_deflt_exEnv;
extern Cor_ExecutionEnv *Cor_exEnv;

extern Cor_ParserStruct *Cor_parserStruct;
extern CoralConfig      *coralConfig;
extern Cor_TableStack   *Cor_T_Stack;

extern Cor_ParseStack   *Cor_parseStack;
extern Cor_ParserEnv    *Cor_parseEnv;

extern Cor_User         *Cor_curUser;
extern Cor_Connection   *Cor_curConn;
extern Cor_ConnectArray *Cor_clients;

class  Cor_DatabaseStruct;
class  Cor_SymTable;

extern Cor_DatabaseStruct *Cor_BuiltinDB;
extern Cor_DatabaseStruct *Cor_CurDB;
extern Cor_SymTable       *Cor_DatabaseTable;

class  Cor_break_info;
extern Cor_break_info     *Cor_brk_Info;

class  Cor_Entity_Array;
extern Cor_Entity_Array   *Coral_Free;

class  Cor_BindEnv;
extern Cor_BindEnv        *Cor_UnusedEnv;

class  Cor_suspensionClass;
extern Cor_suspensionClass *Cor_suspension;

class  Cor_Term;
extern Cor_Term *Cor_static_terms;
extern Cor_Term *Cor_usable_terms;

class Cor_StrRefTable;
extern Cor_StrRefTable *Cor_string_ref_table;

class Cor_Relation;
extern Cor_Relation    *Cor_HelpRel;

// *************************************************************************

extern char coral_pid[32];        // Process Id of this coral program

extern CoralStream *cin_strm;
extern CoralStream *cout_strm;
extern CoralStream *cerr_strm;

// *************************************************************************

#endif _Globals_H_
