// *************************************************************************
//    PersistentIndex.h
// *************************************************************************

#ifndef _PersistentIndex_H_
#define _PersistentIndex_H_

#ifdef WITH_PERSISTENCE

#include "GenericIndex.h"

// *************************************************************************

#define Scanning_Persistent 1

#define COR_PERS_INDEX 2

class Cor_PersistentRel;

class Cor_PersistentIndexSet;

// *************************************************************************

class Cor_PersistentIndex : public Cor_GenericIndex {

  friend Cor_PersistentIndexSet;

  protected:
    inline Cor_PersistentRel *p_rel() { return (Cor_PersistentRel *)relation; }

  public:
    int chosen_index;

    Cor_PersistentIndex(Cor_PersistentRel* , Cor_BitVector *);

    virtual void initialize_iterator(Cor_TupleIterator&) {};
    virtual Cor_Tuple *get_next_tuple(Cor_TupleIterator&);
    virtual Cor_BindEnv *get_next(Cor_TupleIterator&);
    virtual int index_type()        { return COR_PERS_INDEX; }
    virtual int is_subsumed(Cor_Tuple *tuple) { return(0); }
    
    virtual int insert_tuple( Cor_Tuple *tuple ) { return(0); };
    virtual void delete_all_tuples(int force_del=0) {};
    virtual void move_all_entries(Cor_GenericIndex *ind) {};
    virtual void reset_index() {};
};

// *************************************************************************

#endif WITH_PERSISTENCE

#endif _PersistentIndex_H_
