#ifndef _RDBDELETEVERSIONS_H_
#define _RDBDELETEVERSIONS_H_

// Delete versions are collections of delete's that differ only by 
// the adornment on them. (they are on the same relation).
// This is just a convenient way to keep a handle on the versions & 
// easily find them.


#include "RdbDelete.h"
#include "RdbRelation.h"
#include "List.h"
#include "BitVector.h"


typedef DList<RdbDelete> RdbDeleteList;

class RdbDeleteVersions
{
  public:

    RdbDeleteVersions(RdbRelation& newRel);

    virtual ~RdbDeleteVersions();

    RdbDelete& Lookup(BitVector& adorn); 
				// find a delete that can delete with the
				// bindings in adorn.
				// create if not found.

    // not impl: int Delete(BitVector& adorn);

    const RdbRelation& Relation() const;

  private:

    RdbDeleteList deleteList;	// list of delete statements

    RdbRelation&  rel;		// relation the delete's are acting on

    RdbDeleteVersions(const RdbDeleteVersions&); // na

    RdbDeleteVersions& operator =(const RdbDeleteVersions&); // na
};


#include "RdbDeleteVersions.i"

#endif // _RDBDELETEVERSIONS_H_
