// *************************************************************************
//    Execute.h
// *************************************************************************

#ifndef _Execute_H_
#define _Execute_H_

#include "ArgList.h"
#include "RelationMisc.h"
#include "Debug.h"

// *************************************************************************

class Cor_QFModuleData;
class Cor_StorageRelation;
class Cor_Table;
class Cor_TupleIterator;
class Cor_ModuleInfo;
class Cor_ParserStruct;
class Cor_BindEnv;
class Cor_SccInfo;

// *************************************************************************

extern Cor_ModuleInfo      *Cor_CurrModuleInfo;

// *************************************************************************

#define DISPLAY_RULES(X) \
    ((Cor_exEnv->GlobalRelationOptions | (X)->rel_options) &  \
           REL_DISPLAY_INSERTIONS)

// *************************************************************************

void Cor_cleanup_do_query(Cor_QFModuleData *md, Cor_StorageRelation *magic,
    Cor_Table *table_copy);

Cor_StorageRelation *Cor_do_query(Cor_QFModuleData *md,
    Cor_StorageRelation *magic, int old_magic_relation,
    Cor_TupleIterator *iterator);

Cor_StorageRelation *Cor_find_local_relation(Cor_CArg& name, int arity);

int Cor_execute_single_rule(Cor_ParserStruct *Cor_parserStruct);

void Cor_PrintSccRecursiveRules(Cor_SccInfo *scc, int start, ostream *outf);
void Cor_PrintSccNonRecursiveRules(Cor_SccInfo *scc, ostream *outf);

// *************************************************************************

#endif _Execute_H_
