// *************************************************************************
//    CoralError.h
// *************************************************************************

#ifndef _CoralError_H_
#define _CoralError_H_

//#include "Arg.h"
#include "CArg.h"

// *************************************************************************
// WARNING : These two constants will have to be redefined as the
// number of constants increases !

#define WARNING_MESSAGE_INDEX  50
#define ERROR_TABLE_SIZE 75

// *************************************************************************
//    Error Codes

#define COR_OK                  0

// Errors in program definition syntax
#define COR_BAD_SYNTAX            -1
#define COR_BAD_ANNO              -2
#define COR_QUIT_IN_MODULE        -3

// Errors during execution
#define COR_NOT_IMPLEMENTED       -4
#define COR_BAD_TUPLE_INSERT      -5
#define COR_BAD_EMPTY_REL         -6
#define COR_BAD_ARGLIST           -7
#define COR_BAD_ARG_TYPE          -8
#define COR_NON_NUMERIC_ARGS      -9
#define COR_NON_NUMERIC_COMP      -10
#define COR_BAD_ARITY             -11
#define COR_BAD_REL_NAME          -12
#define COR_BAD_GLOBAL_VAR        -13
#define COR_EMPTY_ARGLIST         -14
#define COR_NON_STRING_ARG        -15
#define COR_FILE_NOT_FOUND        -16
#define COR_FAILED_COMMAND        -17
#define COR_NESTED_SET_NOT_GROUND -18
#define COR_BAD_SCHEMA            -19
#define COR_TOO_MANY_ARGS         -20
#define COR_INDEX_ERR             -21
#define COR_BAD_TUPLE             -22
#define COR_ESM_ERR               -23
#define COR_MULTIPLE_DB_ERR       -24
#define COR_GROUPING_ON_RHS       -25
#define COR_MODULE_NOT_FOUND      -26
#define COR_RDB_ERR               -27

#define COR_NO_MEMORY             -28
#define COR_FATAL_ERROR           -29
#define COR_INTERNAL_ERROR        -(WARNING_MESSAGE_INDEX - 1)

// Warnings
#define COR_REL_NOT_FOUND          -(WARNING_MESSAGE_INDEX)
#define COR_CANNOT_OPEN_FILE       -(WARNING_MESSAGE_INDEX+1)
#define COR_SIGNAL_RECEIVED        -(WARNING_MESSAGE_INDEX+2)
#define COR_DUP_SCHEMA             -(WARNING_MESSAGE_INDEX+3)
#define COR_IOCTL_ERROR            -(WARNING_MESSAGE_INDEX+4)

// *************************************************************************
// msg is any additional error message to be printed
// fn_name is the name of the function calling CORAL_error.

void CORAL_error(int err_code, char *msg, char *fn_name, 
        char *file = NULL, int line_no = 0);

// *************************************************************************

#endif _CoralError_H_
