// *************************************************************************
//    TableStack.h
// *************************************************************************

#ifndef _TableStack_H_
#define _TableStack_H_

#include "Table.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************

class  Cor_TableStack;
extern Cor_TableStack   *Cor_T_Stack;
extern Cor_ExecutionEnv *Cor_exEnv;

class Cor_TableStack {

  public:
    Cor_Table **tables;
    int count;

    inline Cor_QFModuleData *cur_md() { return tables[count-1]->moduledata; }
    inline Cor_Table *& operator[](int index) const { return tables[index]; }
    inline Cor_Table *top() const { return tables[count-1]; }

    inline void push(Cor_Table *new_entry) {
        if (Cor_T_Stack->count >= Cor_exEnv->C_max_recursion_depth_default) {
            *(Cor_exEnv->err_strm) << 
                "CORAL Error::Out of recursion stack space !!\n";
            *(Cor_exEnv->err_strm) << " Current max stack size = "
                << Cor_exEnv->C_max_recursion_depth_default << endl;
            *(Cor_exEnv->err_strm) << 
                " Use assign(recursion_depth, <new_value>) to increase it !\n";
            *(Cor_exEnv->err_strm) << " Aborting query !\n";
            Cor_exEnv->C_interrupt_raised = 1;
        }
        tables[count++] = new_entry;
    }

    inline void pop() {
        tables[--count] = NULL;
    }

    inline void empty_stack() {
        if (count <= 0)
            return;
        Cor_Table *tos = top();
        while(count) {
            pop();
            delete tos;
            tos = top();
        }
    }

    Cor_TableStack(int size) {
        tables = new Cor_Table *[size];
        count = 0;
    }

   ~Cor_TableStack() {
        empty_stack();
        delete [] tables;
    }
};

// *************************************************************************

#endif _TableStack_H_
