// *************************************************************************
//    TupleList.h
// *************************************************************************

#ifndef _TupleList_H_
#define _TupleList_H_

#include "Tuple.h"
#include "TupleStack.h"
#include "Debug.h"

// *************************************************************************
//    TupleList is a list of Tuples (chained using TupleLink).

class Cor_TupleList {

  public:

    int             own_stk;        // Is the stack ours to delete?
    Cor_TupleStack *stk;            // List of Tuples

    Cor_TupleList(Cor_TupleStack *s=NULL) {
        if (s) {
            stk = s;
            own_stk = 0;
        } else {
            stk = new Cor_TupleStack(32);
            own_stk = 1;
        }
    }

    Cor_TupleStack *list() { return(stk); }
    void set_list(Cor_TupleStack *lst) { stk=lst; own_stk=0; }


   ~Cor_TupleList() {
        free_all();
        delete stk;
    }

    inline int tlist_insert_tuple(Cor_Tuple *tuple) {
              // only if tuple not deleted
        if (!tuple->is_deleted()) {
            stk->push(UnknownHashValue,tuple);
            tuple->in_tlist = 1;
            return(1);
        }
        return(0);
    }

    void free_all(int deleteTuples=1);
};

// *************************************************************************

#endif _TupleList_H_
